• poj3126(Prime Path)广搜+素数判定


    Description

    The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
    — It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
    — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
    — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
    — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
    — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
    — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

    Now, the minister of finance, who had been eavesdropping, intervened. 
    — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
    — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
    — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
    1033 
    1733 
    3733 
    3739 
    3779 
    8779 
    8179
    The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

    Input

    One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

    Output

    One line for each case, either with a number stating the minimal cost or containing the word Impossible.

    Sample Input

    3
    1033 8179
    1373 8017
    1033 1033

    Sample Output

    6
    7
    0


    大水题,40入口的BFS,剪枝后远远没有40入口。


    #include <iostream>
    #include <sstream>
    #include <fstream>
    #include <string>
    #include <map>
    #include <vector>
    #include <list>
    #include <set>
    #include <stack>
    #include <queue>
    #include <deque>
    #include <algorithm>
    #include <functional>
    #include <iomanip>
    #include <limits>
    #include <new>
    #include <utility>
    #include <iterator>
    #include <cstdio>
    #include <cstdlib>
    #include <cstring>
    #include <cctype>
    #include <cmath>
    #include <ctime>
    using namespace std;
    
    const int maxp = 10010;
    
    bool isPrime[maxp];
    int a, b;
    
    void init()
    {
        fill(isPrime, isPrime+maxp, true);
        for (int i = 2; i < maxp; ++i)
            if (isPrime[i])
                for (int j = i*i; j < maxp; j += i)
                    isPrime[j] = false;
    }
    
    int bfs()
    {
        int vis[maxp];
        memset(vis, -1, sizeof(vis));
        queue<int> q;
        q.push(a);
        vis[a] = 0;
        while (!q.empty())
        {
            int num = q.front();
            q.pop();
            if (num == b)
                return vis[num];
            for (int i = 0; i < 4; ++i)
                for (int j = 0; j < 10; ++j)
                    if (i != 3 || j)
                    {
                        int t = (int)(pow(10, i) + 0.5);
                        int c = num - ((num / t) % 10) * t + j * t;
                        if (isPrime[c] && vis[c] == -1)
                        {
                            q.push(c);
                            vis[c] = vis[num] + 1;
                        }
                    }
        }
        return -1;
    }
    
    int main()
    {
        init();
        int T;
        cin >> T;
        while (T--)
        {
            scanf("%d%d", &a, &b);
            int ans = bfs();
            if (ans == -1)
                printf("Impossible
    ");
            else
                printf("%d
    ", bfs());
        }
        return 0;
    }
    


  • 相关阅读:
    一张图搞定OAuth2.0
    OAuth2.0的refresh token
    ACCESS_TOKEN与FRESH_TOKEN
    关于token和refresh token
    如何解决前后端token过期问题
    对外开放的接口验证方式
    python api接口认证脚本
    Python Thrift 简单示例
    整数中1出现的次数(从1到n整数中1出现的次数)
    连续子数组的最大和
  • 原文地址:https://www.cnblogs.com/godweiyang/p/12203947.html
Copyright © 2020-2023  润新知